org.apache.tools.ant.taskdefs.optional

## Class ReplaceRegExp

- java.lang.Object
- - org.apache.tools.ant.ProjectComponent
  - - org.apache.tools.ant.Task
    - - org.apache.tools.ant.taskdefs.optional.ReplaceRegExp

- All Implemented Interfaces:
    java.lang.Cloneable

      public class ReplaceRegExp
      extends Task

  Performs regular expression string replacements in a text file. The input file(s) must be able to be properly processed by a Reader instance. That is, they must be text only, no binary. The syntax of the regular expression depends on the implementation that you choose to use. The system property `ant.regexp.regexpimpl` will be the classname of the implementation that will be used (the default is `org.apache.tools.ant.util.regexp.JakartaOroRegexp` and requires the Jakarta Oro Package).

       Available implementations:

         org.apache.tools.ant.util.regexp.Jdk14RegexpRegexp (default)
              Uses Java's built-in regular expression package

         org.apache.tools.ant.util.regexp.JakartaOroRegexp
              Requires  the jakarta-oro package

         org.apache.tools.ant.util.regexp.JakartaRegexpRegexp
              Requires the jakarta-regexp package

       Usage:

         Call Syntax:

           <replaceregexp file="file"
                          match="pattern"
                          replace="pattern"
                          flags="options"?
                          byline="true|false"? >
             regexp?
             substitution?
             fileset*
           </replaceregexp>

          NOTE: You must have either the file attribute specified, or at least one fileset subelement
          to operation on.  You may not have the file attribute specified if you nest fileset elements
          inside this task.  Also, you cannot specify both match and a regular expression subelement at
          the same time, nor can you specify the replace attribute and the substitution subelement at
          the same time.

         Attributes:

           file    --> A single file to operation on (mutually exclusive
                          with the fileset subelements)
           match   --> The Regular expression to match
           replace --> The Expression replacement string
           flags   --> The options to give to the replacement
                       g = Substitute all occurrences. default is to replace only the first one
                       i = Case insensitive match

           byline  --> Should this file be processed a single line at a time (default is false)
                       "true" indicates to perform replacement on a line by line basis
                       "false" indicates to perform replacement on the whole file at once.

        Example:

           The following call could be used to replace an old property name in a ".properties"
           file with a new name.  In the replace attribute, you can refer to any part of the
           match expression in parenthesis using backslash followed by a number like '\1'.

           <replaceregexp file="test.properties"
                          match="MyProperty=(.*)"
                          replace="NewProperty=\1"
                          byline="true" />

- - ### Field Summary

    - ### Fields inherited from class org.apache.tools.ant.Task

      `target, taskName, taskType, wrapper`

    - ### Fields inherited from class org.apache.tools.ant.ProjectComponent

      `description, location, project`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReplaceRegExp()` Default Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addConfigured(ResourceCollection rc)` Support arbitrary file system based resource collections.
    `void` | `addFileset(FileSet set)` list files to apply the replacement to
    `RegularExpression` | `createRegexp()` A regular expression.
    `Substitution` | `createSubstitution()` A substitution pattern.
    `protected void` | `doReplace(java.io.File f, int options)` Perform the replacement on a file
    `protected java.lang.String` | `doReplace(RegularExpression r, Substitution s, java.lang.String input, int options)` Invoke a regular expression (r) on a string (input) using substitutions (s) for a matching regex.
    `void` | `execute()` Execute the task
    `void` | `setByLine(boolean byline)` Process the file(s) one line at a time, executing the replacement on one line at a time.
    `void` | `setByLine(java.lang.String byline)` Deprecated. since 1.6.x. Use setByLine(boolean).
    `void` | `setEncoding(java.lang.String encoding)` Specifies the encoding Ant expects the files to be in - defaults to the platforms default encoding.
    `void` | `setFile(java.io.File file)` file for which the regular expression should be replaced; required unless a nested fileset is supplied.
    `void` | `setFlags(java.lang.String flags)` The flags to use when matching the regular expression.
    `void` | `setMatch(java.lang.String match)` the regular expression pattern to match in the file(s); required if no nested <regexp> is used
    `void` | `setPreserveLastModified(boolean b)` Whether the file timestamp shall be preserved even if the file is modified.
    `void` | `setReplace(java.lang.String replace)` The substitution pattern to place in the file(s) in place of the regular expression.

    - ### Methods inherited from class org.apache.tools.ant.Task

      `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

    - ### Methods inherited from class org.apache.tools.ant.ProjectComponent

      `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ReplaceRegExp

          public ReplaceRegExp()

      Default Constructor

  - ### Method Detail

    - #### setFile

          public void setFile(java.io.File file)

      file for which the regular expression should be replaced; required unless a nested fileset is supplied.
      Parameters:
        `file` - The file for which the reg exp should be replaced.

    - #### setMatch

          public void setMatch(java.lang.String match)

      the regular expression pattern to match in the file(s); required if no nested <regexp> is used
      Parameters:
        `match` - the match attribute.

    - #### setReplace

          public void setReplace(java.lang.String replace)

      The substitution pattern to place in the file(s) in place of the regular expression. Required if no nested <substitution> is used
      Parameters:
        `replace` - the replace attribute

    - #### setFlags

          public void setFlags(java.lang.String flags)

      The flags to use when matching the regular expression. For more information, consult the Perl5 syntax.
      - g : Global replacement. Replace all occurrences found
      - i : Case Insensitive. Do not consider case in the match
      - m : Multiline. Treat the string as multiple lines of input, using "^" and "$" as the start or end of any line, respectively, rather than start or end of string.
      - s : Singleline. Treat the string as a single line of input, using "." to match any character, including a newline, which normally, it would not match.
      Parameters:
        `flags` - the flags attribute

    - #### setByLine

          @Deprecated
          public void setByLine(java.lang.String byline)

      Deprecated. since 1.6.x. Use setByLine(boolean).
      Process the file(s) one line at a time, executing the replacement on one line at a time. This is useful if you want to only replace the first occurrence of a regular expression on each line, which is not easy to do when processing the file as a whole. Defaults to false.
      Parameters:
        `byline` - the byline attribute as a string

    - #### setByLine

          public void setByLine(boolean byline)

      Process the file(s) one line at a time, executing the replacement on one line at a time. This is useful if you want to only replace the first occurrence of a regular expression on each line, which is not easy to do when processing the file as a whole. Defaults to false.
      Parameters:
        `byline` - the byline attribute

    - #### setEncoding

          public void setEncoding(java.lang.String encoding)

      Specifies the encoding Ant expects the files to be in - defaults to the platforms default encoding.
      Parameters:
        `encoding` - the encoding attribute
      Since:
        Ant 1.6

    - #### addFileset

          public void addFileset(FileSet set)

      list files to apply the replacement to
      Parameters:
        `set` - the fileset element

    - #### addConfigured

          public void addConfigured(ResourceCollection rc)

      Support arbitrary file system based resource collections.
      Parameters:
        `rc` - ResourceCollection
      Since:
        Ant 1.8.0

    - #### createRegexp

          public RegularExpression createRegexp()

      A regular expression. You can use this element to refer to a previously defined regular expression datatype instance
      Returns:
        the regular expression object to be configured as an element

    - #### createSubstitution

          public Substitution createSubstitution()

      A substitution pattern. You can use this element to refer to a previously defined substitution pattern datatype instance.
      Returns:
        the substitution pattern object to be configured as an element

    - #### setPreserveLastModified

          public void setPreserveLastModified(boolean b)

      Whether the file timestamp shall be preserved even if the file is modified.
      Parameters:
        `b` - boolean
      Since:
        Ant 1.8.0

    - #### doReplace

          protected java.lang.String doReplace(RegularExpression r,
                                               Substitution s,
                                               java.lang.String input,
                                               int options)

      Invoke a regular expression (r) on a string (input) using substitutions (s) for a matching regex.
      Parameters:
        `r` - a regular expression
        `s` - a Substitution
        `input` - the string to do the replacement on
        `options` - The options for the regular expression
      Returns:
        the replacement result

    - #### doReplace

          protected void doReplace(java.io.File f,
                                   int options)
                            throws java.io.IOException

      Perform the replacement on a file
      Parameters:
        `f` - the file to perform the replacement on
        `options` - the regular expressions options
      Throws:
        `java.io.IOException` - if an error occurs

    - #### execute

          public void execute()
                       throws BuildException

      Execute the task
      Overrides:
        `execute` in class `Task`
      Throws:
        `BuildException` - is there is a problem in the task execution.